




//	This source and Genetic Text Complexity Display method apply to GNU General Public License. 
//			Copyright (C) 2001-2009 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//
//			written by Dzinleski Jasenko July,2010






#include 	<stdio.h>
#include 	<string.h>
#include 	<math.h>

#define		ngr	10			//number probe groups - datasets
#define		npr	19			//number of scans in a single group
#define		ps	3000			//number of (6 - literall) groups inside a single permutation group 

char 		infn[256]="res_lc_seg_FGH.txt";	// JKL permutation group

FILE		*f1,*f2;

char		c1[256]="./11c_11/";
char		c2[256]="./11c_12/";
char		c3[256]="./11c_13/";
char		c4[256]="./11c_14/";
char		c5[256]="./11c_15/";
char		c6[256]="./11c_16/";
char		c7[256]="./11c_17/";
char		c8[256]="./11c_18/";
char		c9[256]="./11c_19/";
char		c10[256]="./11c_110/";

char		cs[10][256];

int		ds[ngr][npr][ps];	
long		bp[ps];				int	bpi=0;
char		bs[ps][6+1];


int c_1()
{


	char		fld[256];
	int		fl;

	int		fbyte;
	int		ai;

	int 		i,j,k,l,m;

	int		n,p;
	int		a,b,c;
	int		b1=0,b2=0,b3=0;

	f1=fopen(infn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		for(j=0;j<256;++j){fld[j]='\0';}fl=0;
		while(!feof(f1)&&fbyte!=13&&fbyte!=10){fld[fl]=fbyte;++fl;fbyte=getc(f1);}
		while(!feof(f1)&&fbyte==13||fbyte==10){fbyte=getc(f1);}
				
		//ps
		b1=-1;
		if(bpi==0)
		{
			j=0;for(i=0;i<6;++i){bs[bpi][j]=fld[i];++j;}bs[bpi][j]='\0';
			bp[bpi]=
			((-65+fld[0])<<20)|
			((-65+fld[1])<<16)|
			((-65+fld[2])<<12)|
			((-65+fld[3])<< 8)|
			((-65+fld[4])<< 4)|
			((-65+fld[5])<< 0);
			b1=bpi;
			++bpi;
		}else{ 			
			for(i=0;i<bpi;++i)
			{
				if
				(
				bp[i]==
					(
						((-65+fld[0])<<20)	|
						((-65+fld[1])<<16)	|
						((-65+fld[2])<<12)	|
						((-65+fld[3])<< 8)	|
						((-65+fld[4])<< 4)	|
						((-65+fld[5])<< 0)
					)
				){break;}
			}
			if(i==bpi)
			{
				j=0;for(i=0;i<6;++i){bs[bpi][j]=fld[i];++j;}bs[bpi][j]='\0';
				bp[bpi]=
				((-65+fld[0])<<20)|
				((-65+fld[1])<<16)|
				((-65+fld[2])<<12)|
				((-65+fld[3])<< 8)|
				((-65+fld[4])<< 4)|
				((-65+fld[5])<< 0);
				b1=bpi;
				++bpi;
			}else{b1=i;}
		}
		if(b1==-1){printf("Error\n");}

		//gr #
		b2=-1;
		for(l=0;l<ngr;++l)
		{
			for(i=0;i<strlen(fld)-strlen(cs[l]);++i)
			{
				for(j=0;j<strlen(cs[l]);++j)
				{
					if(cs[l][j]!=fld[i+j]){break;}
				}
				if(j==strlen(cs[l])){break;}
			}
			if(i!=strlen(fld)-strlen(cs[l])){b2=l;break;}
		}
		if(b2==-1){printf("Error\n");}

		//occ # 
		for(i=-1+strlen(fld);i>=0;--i)
		{
			if(fld[i]==' ')
			{
				--i;
				n=0;k=0;
				for(j=i;j>=0&&fld[j]!=' ';--j){n+=(-48+fld[j])*pow(10,k);++k;}
				break;
			}
		}

		//pr #		
		for(i=-1+strlen(fld);i>=0;--i)
		{
			if(fld[i]=='_')
			{
				for(l=i+1;l<strlen(fld);++l){if(fld[l]=='/'){break;}}
				--l;
				p=0;k=0;
				for(j=l;j>=0&&fld[j]!='_'&&fld[j]!='a';--j)
				{p+=(-48+fld[j])*pow(10,k);++k;}
				break;
			}
		}
		--p;

		printf("!%d %d %d %d !\n",b2,p,b1,n);			
		ds[b2][p][b1]=n;	
	
	}
	fclose(f1);

	return(0);

}

int main()
{
	int	i,j,k,l,m,n;
	int	a,b,c,d;

	for(i=0;i<ps;++i){bp[i]=-1;}
	for(i=0;i<ngr;++i){for(j=0;j<npr;++j){for(k=0;k<ps;++k){ds[i][j][k]=-1;}}}

	j=0;for(i=0;i<strlen(c1);++i){cs[0][j]=c1[i];++j;}
	j=0;for(i=0;i<strlen(c2);++i){cs[1][j]=c2[i];++j;}
	j=0;for(i=0;i<strlen(c3);++i){cs[2][j]=c3[i];++j;}
	j=0;for(i=0;i<strlen(c4);++i){cs[3][j]=c4[i];++j;}
	j=0;for(i=0;i<strlen(c5);++i){cs[4][j]=c5[i];++j;}
	j=0;for(i=0;i<strlen(c6);++i){cs[5][j]=c6[i];++j;}
	j=0;for(i=0;i<strlen(c7);++i){cs[6][j]=c7[i];++j;}
	j=0;for(i=0;i<strlen(c8);++i){cs[7][j]=c8[i];++j;}
	j=0;for(i=0;i<strlen(c9);++i){cs[8][j]=c9[i];++j;}
	j=0;for(i=0;i<strlen(c10);++i){cs[9][j]=c10[i];++j;}

	c_1();

	printf("\n");

	printf("\n");

	for(j=0;j<ngr;++j)
	{
		printf("%s\n",cs[j]);
		for(i=0;i<bpi;++i){
			printf("%c%s%c",(char)9,bs[i],(char)9);
			for(k=0;k<npr;++k){
						if(ds[j][k][i]!=-1)
						{
							printf("%c%d",(char)9,ds[j][k][i]);
						}else{printf("%c%d",(char)9,0);}
		}printf("\n");}printf("\n");
	}

	for(j=0;j<ngr;++j)
	{
		for(i=0;i<bpi;++i){
			l=0;
			for(k=0;k<npr;++k)
			{
				if(ds[j][k][i]!=-1){++l;if(l==1){a=k;}}else{
					if(l>=2)
					{	printf("%s",cs[j]);printf("%c%s%c",(char)9,bs[i],(char)9);
						c=0;for(b=a;b<k;++b){c+=ds[j][b][i];printf("%c%d%c%d",(char)9,b,(char)9,ds[j][b][i]);}
					}
					if(l>=2){for(b=0;b<25-2*l;++b){printf("%c",(char)9);}printf("%d%c%d\n",l,(char)9,c);}l=0;
				}
			}
		}
	}

	return(0);

}

