//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2006 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			Genetic Text Complexity Display
//			written by Dzinleski Jasenko December,2005
//
//			to Maria Dzinleska


#include <stdio.h>
#include <string.h>
#include <math.h>

char 	in2fn[255]="CL2002042637AA.CEL";
char 	in1fn[255]="xd.txt";

FILE	*f1;

int	ca[750][750][3];
int	cax,cay;

double	bb[150000][2];
int	bbi=0;

int	ga[150000][2+4];
int	gai=0;

char	pn[256];

double p_val(char arr0[256])
{

	int		j,k=0,l;
	double	fr;

	int		rvi;
	long	rvl;
	double	rvd;

	for(j=0;j<strlen(arr0);++j){if(arr0[j]=='.'){break;}}

	if(j==strlen(arr0))
	{
		rvl=0;l=-1;
		for(j=-1+strlen(arr0);j>=0;--j)
		{
			++l;rvl+=(-48+arr0[j])*pow(10,l);
		}
		rvi=(int)rvl;
		rvd=(double)rvl;

	}else{

			fr=0;l=-1;
			for(k=-1+strlen(arr0);k>j;--k)
			{
				++l;fr+=(double)(-48+arr0[k])*pow(10,l);
			}

			rvd=0;l=-1;
			for(k=j-1;k>=0;--k)
			{
				++l;rvd+=(double)(-48+arr0[k])*pow(10,l);
			}rvd*=pow(10,strlen(arr0)-j-1);

			rvd=(rvd+fr)/pow(10,strlen(arr0)-j-1);
				
	}

	return(rvd);
}

int main(int argc,char *argv[])
{

	char p1[20];
	char p2[20];

	int	fbyte;

	char	cc[4];
	int	cci=0;

	int	i,j,k,l,m,n,nx,ny;
	int	a,b,c;
	int	xv,mv;

	double	mvd;
	double	kt,lt;

	char	fr[1024];
	int	fri=0;

	if(argv[1]!=NULL){strcpy(in1fn,argv[1]);f1=fopen(in1fn,"rb");if(f1!=NULL){fclose(f1);}else{return(0);}}else{return(0);}
	if(argv[2]!=NULL){strcpy(in2fn,argv[2]);f1=fopen(in2fn,"rb");if(f1!=NULL){fclose(f1);}else{return(0);}}else{return(0);}

	for(i=0;i<1024;++i){fr[i]='\0';}fri=0;

	printf("%s\n",in1fn);
	f1=fopen(in1fn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		while(fbyte!=10&&fbyte!=13&&!feof(f1)){fr[fri]=fbyte;++fri;fbyte=getc(f1);}
		while(fbyte==10||fbyte==13&&!feof(f1)){fbyte=getc(f1);}

		if(fr[0]=='#'){for(i=0;i<1024;++i){fr[i]='\0';}fri=0;continue;}

		for(j=0;j<fri;++j){if(fr[j]==(char)9){break;}}
		bb[bbi][0]=0;a=0;for(i=0;i<256;++i){pn[i]='\0';}
		l=0;for(i=0;i<fri&&((fr[i]>='0'&&fr[i]<='9')||fr[i]=='.'||fr[i]=='-');++i){pn[l]=fr[i];++l;}j=i;
		//printf(" %s ",pn);
		bb[bbi][0]=p_val(pn);
		//printf("%e\n",bb[bbi][0]);

		bb[bbi][1]=0;a=0;for(i=0;i<256;++i){pn[i]='\0';}
		l=0;for(i=j+1;i<fri&&((fr[i]>='0'&&fr[i]<='9')||fr[i]=='.'||fr[i]=='-');++i){pn[l]=fr[i];++l;}j=i;
		bb[bbi][1]=p_val(pn);

		++bbi;

		for(i=0;i<1024;++i){fr[i]='\0';}fri=0;
	}
	fclose(f1);

	for(i=0;i<750;++i){for(j=0;j<750;++j){ca[i][j][0]=-1;}}

	for(i=0;i<1024;++i){fr[i]='\0';}fri=0;

	printf("%s\n",in2fn);
	f1=fopen(in2fn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		while(fbyte!=10&&fbyte!=13){fr[fri]=fbyte;++fri;fbyte=getc(f1);}
		while(fbyte==10||fbyte==13){fbyte=getc(f1);}

		j=0;for(i=0;i<fri;++i){if(fr[i]==9){++j;}}
		if(j!=4){for(i=0;i<1024;++i){fr[i]='\0';}fri=0;continue;}

		j=0;for(i=0;i<fri;++i){if(fr[i]==9){++j;}if(j==2){j=i;break;}}
		l=0;for(i=j+1;i<fri;++i){if(fr[i]==' '||(fr[i]>='0'&&fr[i]<='9')){if(fr[i]>='0'&&fr[i]<='9'){++l;}}else{break;}}//printf(".%d.",l);
		n=0;for(k=i-l;k<i&&fr[k]!='.';++k){--l;n+=(fr[k]-48)*pow(10,l);}
		//printf(" %d ",n);
		xv=n;

		j=0;for(i=0;i<fri;++i){if(fr[i]==9){++j;}if(j==3){j=i;break;}}
		for(i=0;i<256;++i){pn[i]='\0';}
		l=0;for(i=j+1;i<fri&&((fr[i]>='0'&&fr[i]<='9')||fr[i]=='.');++i){pn[l]=fr[i];++l;}
		//printf(" %s ",pn);
		mvd=p_val(pn);mv=(int)mvd;
		
		l=0;for(i=0;i<fri;++i){if(fr[i]==' '||(fr[i]>='0'&&fr[i]<='9')){if(fr[i]>='0'&&fr[i]<='9'){++l;}}else{break;}}//printf(".%d.",l);
		nx=0;for(k=i-l;k<i&&fr[k]!=9;++k){--l;nx+=(fr[k]-48)*pow(10,l);}
		//printf(" %d ",nx);

		j=0;for(i=0;i<fri;++i){if(fr[i]==9){++j;}if(j==1){j=i;break;}}
		l=0;for(i=j+1;i<fri;++i){if(fr[i]==' '||(fr[i]>='0'&&fr[i]<='9')){if(fr[i]>='0'&&fr[i]<='9'){++l;}}else{break;}}//printf(".%d.",l);
		ny=0;for(k=i-l;k<i&&fr[k]!=9;++k){--l;ny+=(fr[k]-48)*pow(10,l);}
		//printf(" %d ",ny);

		cay=nx;
		cax=ny;

		for(i=0;i<bbi-1;++i)
		{
			if(bb[i][0]<=mvd&&mvd<=bb[1+i][0])
			{
				//printf("%d %d %d\n",cay,cax,mv);
				if(gai==0)
				{
					ga[gai][0]=cay;
					ga[gai][1]=cax;
					ga[gai][2]=xv;
					ga[gai][3]=mv;
					ga[gai][4]=(int)bb[i][0];
					ga[gai][5]=(int)bb[1+i][0];
					++gai;
				}else{
					if(cay==1+ga[-1+gai][0])
					{
						ga[gai][0]=cay;
						ga[gai][1]=cax;
						ga[gai][2]=xv;
						ga[gai][3]=mv;
						ga[gai][4]=(int)bb[i][0];
						ga[gai][5]=(int)bb[1+i][0];
						++gai;
					}else{
						if(gai>=3)
						{
							for(j=0;j<gai;++j)
							{
								printf("%d\t%d\t%d\t%d\t%c%c%c%c\t",ga[j][0],ga[j][1],ga[j][2],ga[j][3],65+((((ga[j][4]+ga[j][5])/2)&0xf000)>>12),65+((((ga[j][4]+ga[j][5])/2)&0x0f00)>>8),65+((((ga[j][4]+ga[j][5])/2)&0x00f0)>>4),65+((((ga[j][4]+ga[j][5])/2)&0x000f)>>0));
								for(k=0;k<bbi-1;++k)
								{
									if((int)bb[k][0]==ga[j][4]&&(int)bb[1+k][0]==ga[j][5]){printf("%d %d-%d\n",k,(int)bb[k][0],(int)bb[1+k][0]);break;}
								}
							}
							printf("\n");
						}
						gai=0;
					}
				}
				break;
			}
		}

		for(i=0;i<1024;++i){fr[i]='\0';}fri=0;
	}
	fclose(f1);

	return(0);
}
	